C--------------------------------------------------------------------
C     CALCULATE STRUCTURE FACTORS. ( TYPE-F ) from asym. unit density
C--------------------------------------------------------------------
C
      SUBROUTINE CSTRCTF(masym,nasym,RDEN,RMIC
     $                  ,RMIS
     $                  ,RASYM,mref,nref,FCAL,ff1)
C
      integer*4 masym,nasym,ia
      integer mref,nref,iref
      real*8 RDEN(masym),RASYM(masym),FCAL(2,mref),RMIC(mref,masym)
      real*8 RMIS(mref,masym),fi
      real*8 ff1,fr,r
C
      DO 210 iref=1,nref
         fr=0.0
         fi=0.0
         DO 220 ia=1,nasym
            r = RDEN(ia)/RASYM(ia)
            fr=fr+r*RMIC(iref,ia)
            fi=fi+r*RMIS(iref,ia)
  220    CONTINUE
         FCAL(1,iref)=fr*ff1
         FCAL(2,iref)=fi*ff1
  210 CONTINUE
C
      RETURN
      END
C
