C--------------------------------------------------------------------
C     Input new values for RAMDA and ALPHA
C     PRESERVE HISTORY OF CHANGES OF lambda.
C--------------------------------------------------------------------
C
      SUBROUTINE HISTRY(itcycl,delta,alpha,lambda,nhist,
     $                  mhist,FHIST,IHIST,connew)
C
      IMPLICIT none
      integer mhist
      integer IHIST(mhist),itcycl,nhist,i
      real*8 FHIST(3,mhist),delta,alpha,lambda,connew,wert
      logical CR,error
C
1000  FORMAT(a)
1001  FORMAT(a,' [default value=',g15.8,']')
3000  FORMAT(' !!! THE CONSTRAINT FUNCTION DIVERGES !!!')
C
10    IF (delta.GE.0.0) then
        WRITE(6,3000)
        WRITE(*,1001) 'Input a smaller value for lamda. ',lambda
      else
        WRITE(*,1001) 'Input a new value for lamda. ',lambda
      endif
      write(*,1000)
     $   '(hit the RETURN key, if you do not want to change it)'
      CALL abfrage(wert,i,CR,error)
      if (error) goto 10
      if (.not.CR) then
        if (wert.lt.0) then
          print *,'wrong input'
          goto 10
        else
          nhist=nhist+1
	  if (nhist.gt.mhist) nhist=mhist
          FHIST(1,nhist)=lambda
          lambda=wert
          FHIST(2,nhist)=lambda
          FHIST(3,nhist)=connew
          IHIST(nhist)=itcycl
        endif
      else
	print *,'lambda unchanged'
      endif

20    WRITE(*,1001) 'Input a new final CON-value. ',alpha
      CALL abfrage(wert,i,CR,error)
      if (error) goto 20
      if (.not.CR) then
        if (wert.lt.0) then
          print *,'wrong input'
          goto 20
        else
          alpha=wert
        endif
      else
	print *,'CON-value unchanged'
      endif
C
      RETURN
      END
