C--------------------------------------------------------------------
C     MAKE PREFERED ORIENTATION CORRECTION FACTOR
C     ON EACH REFLECTION.
C--------------------------------------------------------------------
C
      SUBROUTINE POCOR(iptyp,pop,PROF,nref,mref,IDX,
     $	               as,bs,cs,ga,gb,gg,rh,rk,rl,pi)
      IMPLICIT INTEGER (I-N)
      IMPLICIT REAL*8 (A-H,O-Z)
      dimension PROF(mref),IDX(3,mref) 
C
      do 10 iref=1,nref
      IF (IPTYP.lt.0) THEN
         PROF(iref)=1.0
      ELSE
         JH=IDX(1,iref)
         JK=IDX(2,iref)
         JL=IDX(3,iref)
         QH=DFLOAT(JH)*AS
         QK=DFLOAT(JK)*BS
         QL=DFLOAT(JL)*CS
         S1=QH*QH+QK*QK+QL*QL
         S2=RH*RH+RK*RK+RL*RL
         S3=RH*QH+RK*QK+RL*QL
         S4=0.5*RH*(QK*GG+QL*GB)
         S5=0.5*RK*(QH*GG+QL*GA)
         S6=0.5*RL*(QH*GB+QK*GA)
         QR=(S3+S4+S5+S6)/SQRT(S1*S2)
         QQ=DCOS(QR)
C*** CASE : NEEDLE LIKE ORIENTATION ***
         IF(IPTYP.NE.0) QQ=PI/2.0-QQ
C*** CAUTION : PROF=SQRT( P(PHI) ) ***
         PROF(iref)=DEXP(-0.5*POP*QQ*QQ)
      END IF
10    continue
C
      RETURN
      END
