C     save density of RDEN() array, together with symmetry information 
C  
      SUBROUTINE SAVEDEN(filden,
     $   masym,nasym,title,IASYM,RDEN,CELL,NPIX
     $   ,nsym,ncen,nsub,IROT,RTRS,RSUB)
      IMPLICIT none
      integer*4 masym,nasym,ia
      real*8 RDEN(masym),CELL(6),RTRS(3,48),RSUB(3,4)
      integer IASYM(3,masym),NPIX(3),IROT(3,3,48)
      integer nsym,ncen,nsub,i,j,isym
      character title*200,filden*50
C
      OPEN(20,FILE=FILDEN,FORM='FORMATTED',
     $     STATUS='UNKNOWN', ACCESS='SEQUENTIAL')
1010  format(6F10.5)
1020  format(6i5)
1040  format(i7)
1070  format(f7.5,1x,f7.5,1x,f7.5)
1080  format(a,a,a)
C***  fuer VAX: 1080  format(a80)
1090  format(3(I4,1X),G21.6)
C   1100  format(12i5)       ! old symmetry operator format
1100  format(3(3i4,2x),2x,3(1x,f7.5)) 
      write(20,1080) title(1:80), title(81:160), title(161:200)
      write(20,1040) nasym
C     write(20,1090) ((IASYM(i,ia),i=1,3),RDEN(ia),ia=1,nasym)
      do 10 ia=1,nasym
10      write(20,1090   ) (IASYM(i,ia),i=1,3),sngl(RDEN(ia))
      write(20,1010) (CELL(i),i=1,6)
      write(20,1020) (NPIX(i),i=1,3),nsym,ncen,nsub
      do 20 isym=1,nsym
        write(20,1100) ((IROT(i,j,isym),j=1,3),i=1,3),
     $                 (RTRS(i,isym),i=1,3)
20    continue
      write(20,1070) ((RSUB(i,isym),i=1,3),isym=1,nsub)
      CLOSE(20)
      return
      end
